function r = runlength(x)
    x = x(:);  % force x to be column vector

    % mx marks with 1 all the places where a run begins in x
    mx = [1;diff(x)]~=0;
    % l are the run lengths
    l = diff([find(mx);length(x)+1]);
    % s are the symbols at the beginning of each run
    s = x(mx);
    p = find(mx);

    r = [s p l];
    ind = s~=0;
    r = r(ind,2:3);
