% Copyright 2013, Yi Yu <yuy@comp.nus.edu.sg>
% This program is for Personal Music Video Generation based on Modeling Scene Moods and is free: 
% You can redistribute it and/or modify
% it under the terms of the GNU General Public License.


function histMood = getHistInfo(recogMood)
    uniqMood = unique(recogMood);
    histMood = zeros(numel(uniqMood),2);
    histMood(:,1) = uniqMood;
    for k=1:numel(uniqMood)
        histMood(k,2) = sum(recogMood==uniqMood(k));
    end;
    histMood = sortrows(histMood, 2);
    histMood = histMood(end:-1:1, :);
    